#ifndef DIYA_OBJECT_H
#define DIYA_OBJECT_H

#include <glib-object.h>
/**
 * Base class object
 * 
 */
#define DIYA_TYPE_OBJECT  (diya_object_get_type ())
G_DECLARE_DERIVABLE_TYPE (DiyaObject, diya_object, DIYA, OBJECT, GObject)

struct _DiyaObjectClass {
  GObjectClass parent_class;
  const gchar* (*to_string)  (DiyaObject *self);
  /**
   * @brief reserve for futur use to
   * define common API for descendants
   * 
   */
};

const gchar* diya_object_to_string(gpointer object);

#endif