#ifndef DIYA_SHELL_H
#define DIYA_SHELL_H
#include <gtk4-layer-shell.h>
#include "base.h"

enum diya_win_state
{
    DIYA_WIN_STATE_NONE = 0,
    DIYA_WIN_STATE_MINIMIZE = 1 << 0,
    DIYA_WIN_STATE_MAXIMIZE = 1 << 1,
    DIYA_WIN_STATE_FULLSCREEN = 1 << 2,
    DIYA_WIN_STATE_FOCUS = 1 << 3,
};

#define DIYA_TYPE_SHELL (diya_shell_get_type ())
G_DECLARE_FINAL_TYPE (DiyaShell, diya_shell, DIYA, SHELL, DiyaObject)

#define DIYA_TYPE_WINDOW (diya_window_get_type ())
G_DECLARE_FINAL_TYPE (DiyaWindow, diya_window, DIYA, WINDOW, DiyaObject)

gpointer diya_shell_get_window(DiyaShell * shell, gpointer handle);
gboolean diya_shell_add_window(DiyaShell * shell, DiyaWindow * win);
gboolean diya_shell_remove_window(DiyaShell * shell, DiyaWindow * win);
DiyaShell * diya_shell_new(GtkApplication * app);

DiyaWindow * diya_window_new(DiyaShell* shell, gpointer handle);
#endif